package com.noorija.secret.guard

import androidx.databinding.BindingAdapter
import androidx.recyclerview.widget.RecyclerView
import com.noorija.secret.guard.adapter.RecyclerAdapter
import com.noorija.secret.guard.model.Todo
import com.noorija.secret.guard.rest.CallHistory
import com.noorija.secret.guard.rest.CasMngInfo
import com.noorija.secret.guard.rest.FaqInfo
import com.noorija.secret.guard.rest.MyQrInfo
import com.noorija.secret.guard.rest.PublicInfo
import com.noorija.secret.guard.view.adapter.CallHistoryAdapter
import com.noorija.secret.guard.view.adapter.CasRecyclerAdapter
import com.noorija.secret.guard.view.adapter.FaqRecyclerAdapter
import com.noorija.secret.guard.view.adapter.HomeRecyclerAdapter
import com.noorija.secret.guard.view.adapter.MyQrcodeAdapter
import com.noorija.secret.guard.view.adapter.NoticeRecyclerAdapter

object AppBindingAdapter {
    @BindingAdapter("items")
    @JvmStatic
    fun setItem(recyclerView: RecyclerView, todoList: List<Todo>?) {
        if(recyclerView.adapter == null) {
            val adapter = RecyclerAdapter()
            recyclerView.adapter = adapter
        }

        todoList?.let {
            val myAdapter = recyclerView.adapter as RecyclerAdapter
            myAdapter.submitList(it)
            myAdapter.notifyDataSetChanged()
        }
    }

    @BindingAdapter("casList")
    @JvmStatic
    fun setCasList(recyclerView: RecyclerView, casList: List<CasMngInfo>?) {
        if(recyclerView.adapter != null) {
            val adapter : CasRecyclerAdapter = recyclerView.adapter as CasRecyclerAdapter
            if(casList != null) {
                adapter.updateList(casList)
                adapter.notifyDataSetChanged()
            }
        }
    }

    @BindingAdapter("myQrList")
    @JvmStatic
    fun setMyQrList(recyclerView: RecyclerView, myQrList: List<MyQrInfo>?) {
        if(recyclerView.adapter != null) {
            val adapter : MyQrcodeAdapter = recyclerView.adapter as MyQrcodeAdapter
            if(myQrList != null) {
                adapter.updateList(myQrList)
                adapter.notifyDataSetChanged()
            }
        }
    }

    @BindingAdapter("callHistoryList")
    @JvmStatic
    fun setCallHistoryList(recyclerView: RecyclerView, callHistory: List<CallHistory>?) {
        if(recyclerView.adapter != null) {
            val adapter : CallHistoryAdapter = recyclerView.adapter as CallHistoryAdapter
            if(callHistory != null) {
                adapter.updateList(callHistory)
                adapter.notifyDataSetChanged()
            }
        }
    }

    @BindingAdapter("faqList")
    @JvmStatic
    fun setFaqList(recyclerView: RecyclerView, faqList: List<FaqInfo>?) {
        if(recyclerView.adapter != null) {
            val adapter : FaqRecyclerAdapter = recyclerView.adapter as FaqRecyclerAdapter
            if(faqList != null) {
                adapter.updateList(faqList)
                adapter.notifyDataSetChanged()
            }
        }
    }

    @BindingAdapter("noticeList")
    @JvmStatic
    fun setNoticeList(recyclerView: RecyclerView, noticeList: List<PublicInfo>?) {
        if(recyclerView.adapter != null) {
            val adapter : NoticeRecyclerAdapter = recyclerView.adapter as NoticeRecyclerAdapter
            if(noticeList != null) {
                adapter.updateList(noticeList)
                adapter.notifyDataSetChanged()
            }
        }
    }

    @BindingAdapter("homeList")
    @JvmStatic
    fun setHomeList(recyclerView: RecyclerView, homeList: List<CasMngInfo>?) {
        if(recyclerView.adapter != null) {
            val adapter : HomeRecyclerAdapter = recyclerView.adapter as HomeRecyclerAdapter
            if(homeList != null) {
                adapter.updateList(homeList)
                adapter.notifyDataSetChanged()
            }
        }
    }
}