package com.noorija.secret.guard.manager

import android.content.Context
import com.noorija.rtc.inobs.PeerConnectionObserver
import com.noorija.rtc.socket.OnSocketListener
import com.noorija.rtc.socket.SocketConnectManager
import org.webrtc.SessionDescription
import timber.log.Timber
import java.util.concurrent.atomic.AtomicBoolean

class FindCallRtcManager private constructor(
    context: Context
) : PeerConnectionObserver(), OnSocketListener {

    companion object {
        fun createFindCallRtcManager(context: Context): FindCallRtcManager {
            return FindCallRtcManager(context)
        }
        private const val RTC_HOST_URL = "https://kosk.co.kr/signaling"
    }

    private val isStart = AtomicBoolean(false)
    private val isReleased = AtomicBoolean(false)

    private val socketManager = SocketConnectManager(this)

    fun initModule() {
        Timber.d("====================> FindCallRtcManager initModule")
        socketManager.createSocket(RTC_HOST_URL)
    }

    override fun onPeerError(isCritical: Boolean, showMessage: Boolean, message: String?) {

    }

    override fun onPeerCreate(desc: SessionDescription?) {

    }

    override fun onSocketState(state: String, data: Array<Any>, onComplete: (() -> Unit)?) {
        Timber.d("onSocketState ==================> $state")
        Timber.d("" + data)
        Timber.d("" + onComplete)
    }

}