package com.noorija.secret.guard.rest

import android.os.Parcelable
import com.noorija.secret.guard.model.CasAgreeInfo
import com.noorija.secret.guard.util.StringUtil
import kotlinx.parcelize.Parcelize
import retrofit2.http.Url

data class ReqAppReg(var appReg: String)

data class VerInfoRequest(var deviTpCd: String, var deviId: String, var deviOsVer: String
                          , var appVer: String, var langCd: String, var currentDate: String = StringUtil.getCurrentDate())

@Parcelize
data class SaveCasInfo( val casNo: String, val selectYn: String ) : Parcelable
data class MembRequest(
    var deviTpCd: String, var deviId: String, var deviOsVer: String
    , var appVer: String, var genCd: String, var phoneNo: String
    , var birDt: String, var langCd: String, var currentDate: String, var casList: ArrayList<SaveCasInfo>
)

data class QrUseRegRequest(@Url var qrNo: String, var langCd: String)

data class QrMembRegRequest(var qrNo: String, var nickNm: String, var makerCar: String, var carInfo: String
                            , var deviId: String, var langCd: String, var currentDate: String = StringUtil.getCurrentDate())

data class QrMembDelRequest(var qrNo: String, var langCd: String, var currentDate: String = StringUtil.getCurrentDate())

data class MembSettingRequest(var alarmUseYn: String, var alarmIntervalCd: String, var alarmSoundYn: String
                       , var alarmSoundNm: String, var alarmVibYn: String, var callPhoneYn: String
                       , var callMsgYn: String, var langCd: String, var currentDate: String = StringUtil.getCurrentDate())

data class CallHistoryRequest(var gridSize: Int, var gridPage: Int, var pagingYn: String, var langCd: String)

data class CallReqSendRequest(var qrNo: String, var callSubScr: String, var callSeq: String, var callTypeCd: String
                          , var callReqCd: String, var callReqMsg: String, var langCd: String, var currentDate: String = StringUtil.getCurrentDate())

data class CallCancelSendRequest(var qrNo: String, var callSubScr: String, var langCd: String, var currentDate: String = StringUtil.getCurrentDate())

data class AskRequest(var email: String, var askSubject: String, var askDesc: String, var langCd: String, var currentDate: String = StringUtil.getCurrentDate())

data class AnnounceListRequest(var langCd: String, var currentDate: String, var gridSize: Int, var gridPage: Int, var pagingYn: String)
