package com.noorija.secret.guard.util

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.media.RingtoneManager
import android.net.Uri
import androidx.activity.result.contract.ActivityResultContract


//internal class PickRingtone : ActivityResultContract<Uri, Uri?>() {
//    override fun createIntent(context: Context, existing: Uri): Intent {
//        val intent = Intent(RingtoneManager.ACTION_RINGTONE_PICKER)
//        intent.putExtra(RingtoneManager.EXTRA_RINGTONE_TYPE, RingtoneManager.TYPE_RINGTONE)
//        intent.putExtra(RingtoneManager.EXTRA_RINGTONE_SHOW_DEFAULT, true)
//        intent.putExtra(RingtoneManager.EXTRA_RINGTONE_SHOW_SILENT, true)
//        if (existing != null) {
//            intent.putExtra(RingtoneManager.EXTRA_RINGTONE_EXISTING_URI, existing)
//        }
//        return intent
//    }
//
//    override fun parseResult(resultCode: Int, data: Intent?): Uri? {
//        if (resultCode != Activity.RESULT_OK || data == null) {
//            return null
//        }
//        val pickedUri = data.getParcelableExtra<Uri>(RingtoneManager.EXTRA_RINGTONE_PICKED_URI)
//        return pickedUri ?: NONE
//    }
//
//    companion object {
//        private val NONE: Uri = Uri.parse("about:blank")
//
//        fun noneToNull(uri: Uri?): Uri? {
//            return if (uri == null || NONE == uri) null else uri
//        }
//    }
//}

class PickRingtone: ActivityResultContract<Int, Uri?>() {

    companion object {
        private val NONE: Uri = Uri.parse("about:blank")

        fun noneToNull(uri: Uri?): Uri? {
            return if (uri == null || NONE == uri) null else uri
        }
    }

    override fun createIntent(context: Context, ringtoneType: Int) =
        Intent(RingtoneManager.ACTION_RINGTONE_PICKER).apply {
            putExtra(RingtoneManager.EXTRA_RINGTONE_TYPE, ringtoneType)
        }

    override fun parseResult(resultCode: Int, result: Intent?) : Uri? {
        if (resultCode != Activity.RESULT_OK) {
            return null
        }
        return result?.getParcelableExtra(RingtoneManager.EXTRA_RINGTONE_PICKED_URI)
    }
}