package com.noorija.secret.guard.util

import android.content.Context
import android.content.pm.PackageManager
import android.net.ConnectivityManager
import android.net.NetworkInfo
import androidx.core.content.ContextCompat
import com.google.gson.Gson
import java.util.Locale

object SystemUtil {
    fun isConnected(context: Context): Boolean {
        val cm = context.getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
        val activeNetwork: NetworkInfo? = cm.activeNetworkInfo
        var result = false
        if (activeNetwork != null) {
            result = activeNetwork.isConnectedOrConnecting
        }
        return result
    }

    fun isPermission(context: Context, permissions: Array<String>): Boolean {
        var isGranted = true
        for(permission: String in permissions) {
            if(ContextCompat.checkSelfPermission(context, permission) != PackageManager.PERMISSION_GRANTED) {
                isGranted = false
                break
            }
        }
        return isGranted
    }

    fun <T> jsonToObj(json: String?, clazz: Class<T>) : T {
        return Gson().fromJson(json, clazz)
    }

    fun getSystemLanguage(context: Context): String {
//        val systemLocale: Locale = if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
//            context.resources.configuration.getLocales().get(0)
//        } else {
//            context.resources.configuration.locale
//        }
//        return systemLocale.language
        return Locale.getDefault().country
    }

}