package com.noorija.secret.guard.view

import android.content.Intent
import androidx.activity.viewModels
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.Observer
import com.noorija.secret.guard.R
import com.noorija.secret.guard.databinding.ActAskListBinding
import com.noorija.secret.guard.viewmodel.AskListViewModel

class AskListActivity : BaseActivity() {

    private lateinit var binding : ActAskListBinding
    private val viewModel : AskListViewModel by viewModels()

    override fun initDataBinding() {
        binding = DataBindingUtil.setContentView(this, R.layout.act_ask_list)
        binding.viewModel = viewModel
        binding.lifecycleOwner = this
    }

    override fun initAfterBinding() {
        with(viewModel) {
            closeEvent.observe(this@AskListActivity, Observer {
//                val intent = Intent(this@PreferencesActivity, InfoRegistActivity::class.java)
//                startActivity(intent)
                finish()
            })
        }
    }

    override fun networkConnectivityChanged(isAvailable: Boolean) {

    }
}