package com.noorija.secret.guard.view

import androidx.activity.viewModels
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.Observer
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.noorija.secret.guard.R
import com.noorija.secret.guard.databinding.ActFaqListBinding
import com.noorija.secret.guard.view.adapter.FaqRecyclerAdapter
import com.noorija.secret.guard.viewmodel.FaqListViewModel

class FaqListActivity : BaseActivity() {

    private lateinit var binding : ActFaqListBinding
    private val viewModel : FaqListViewModel by viewModels()

    private lateinit var mRecyclerAdapter : FaqRecyclerAdapter

    override fun initDataBinding() {
        binding = DataBindingUtil.setContentView(this, R.layout.act_faq_list)
        binding.viewModel = viewModel
        binding.lifecycleOwner = this

        setRecyclerView()
    }

    override fun initAfterBinding() {
        with(viewModel) {
            closeEvent.observe(this@FaqListActivity, Observer {
                finish()
            })
        }
    }

    private fun setRecyclerView() {
        mRecyclerAdapter = FaqRecyclerAdapter(viewModel)
        binding.faqRecyclerView.apply {
            adapter = mRecyclerAdapter
            layoutManager = LinearLayoutManager(this@FaqListActivity, RecyclerView.VERTICAL, false)
        }
    }

    override fun networkConnectivityChanged(isAvailable: Boolean) {

    }
}