package com.noorija.secret.guard.view

import android.os.Build
import android.os.Bundle
import androidx.activity.viewModels
import androidx.annotation.RequiresApi
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.Observer
import com.noorija.secret.guard.R
import com.noorija.secret.guard.databinding.ActInfoRegistBinding
import com.noorija.secret.guard.rest.MyQrInfo
import com.noorija.secret.guard.view.fragment.MyQrcodeFragment
import com.noorija.secret.guard.viewmodel.InfoRegistViewModel
import timber.log.Timber

class InfoRegistActivity : BaseActivity() {

    private lateinit var binding : ActInfoRegistBinding
    private val viewModel : InfoRegistViewModel by viewModels()

//    override fun onCreate(savedInstanceState: Bundle?) {
//        super.onCreate(savedInstanceState)
//        binding = DataBindingUtil.setContentView(this, R.layout.act_info_regist)
//        binding.viewModel = viewModel
//        binding.lifecycleOwner = this
//    }

    override fun initDataBinding() {
        binding = DataBindingUtil.setContentView(this, R.layout.act_info_regist)
        binding.viewModel = viewModel
        binding.lifecycleOwner = this

        viewModel.strQrNo = intent.getStringExtra("qrNo").toString()
        if(viewModel.strQrNo.isEmpty()) {
            val myQrInfo : MyQrInfo? = if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                intent.getParcelableExtra("MyQrInfo", MyQrInfo::class.java)
            } else {
                intent.getParcelableExtra("MyQrInfo")
            }
            viewModel.initViewModel(myQrInfo)
        }
    }

    @RequiresApi(Build.VERSION_CODES.O)
    override fun initAfterBinding() {
        with(viewModel) {
            infoRegistEvent.observe(this@InfoRegistActivity, Observer {
                start(MainActivity::class.java)
                finish()
            })
        }
    }

    override fun networkConnectivityChanged(isAvailable: Boolean) {

    }
}