package com.noorija.secret.guard.view

import android.os.Bundle
import androidx.activity.viewModels
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.Observer
import com.noorija.secret.guard.R
import com.noorija.secret.guard.databinding.ActRtcCallBinding
import com.noorija.secret.guard.viewmodel.RtcCallViewModel

class RtcCallActivity : BaseActivity() {

    private lateinit var binding : ActRtcCallBinding
    private val viewModel : RtcCallViewModel by viewModels()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = DataBindingUtil.setContentView(this, R.layout.act_rtc_call)
        binding.viewModel = viewModel
        binding.lifecycleOwner = this
    }

    override fun initDataBinding() {
    }

    override fun initAfterBinding() {
        with(viewModel) {
            closeEvent.observe(this@RtcCallActivity, Observer {
                start(MainActivity::class.java)
                finish()
            })
        }
    }

    override fun networkConnectivityChanged(isAvailable: Boolean) {

    }
}