package com.noorija.secret.guard.view

import android.content.Intent
import androidx.activity.viewModels
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.Observer
import com.noorija.secret.guard.R
import com.noorija.secret.guard.databinding.ActScannerBinding
import com.noorija.secret.guard.viewmodel.ScannerViewModel

class ScannerActivity : BaseActivity() {

    private lateinit var binding : ActScannerBinding
    private val viewModel : ScannerViewModel by viewModels()

    lateinit var callType: String

    override fun initDataBinding() {
        binding = DataBindingUtil.setContentView(this, R.layout.act_scanner)
        binding.viewModel = viewModel
        binding.lifecycleOwner = this

        callType = intent.getStringExtra("CallType")!!
        viewModel.initViewModel(this@ScannerActivity)
    }

    override fun initAfterBinding() {
        with(viewModel) {
            scanEvent.observe(this@ScannerActivity, Observer {
                if(it.isNotBlank()) {
                    if(act.callType == "WebRTC") {
                        startActivity(Intent(this@ScannerActivity, RtcWebViewActivity::class.java).apply {
                            putExtra("RTC_URL", it)
                        })
                    } else {
                        startActivity(Intent(this@ScannerActivity, InfoRegistActivity::class.java).apply {
                            putExtra("qrNo", it)
                        })
                    }
//                    val intent = Intent(this@ScannerActivity, InfoRegistActivity::class.java)
//                    intent.putExtra("qrNo", it)
//                    startActivity(intent)
                }
                finish()
            })
            closeEvent.observe(this@ScannerActivity, Observer {
                finish()
            })
        }
    }

    override fun networkConnectivityChanged(isAvailable: Boolean) {

    }
}