package com.noorija.secret.guard.view

import android.os.Bundle
import androidx.activity.viewModels
import androidx.databinding.DataBindingUtil
import com.noorija.secret.guard.R
import com.noorija.secret.guard.viewmodel.MainViewModel
import com.noorija.secret.guard.databinding.ActMainBinding
import com.noorija.secret.guard.util.BackPressCloseHandler

class TodoActivity : BaseActivity() {
    private lateinit var binding : ActMainBinding
    private val viewModel : MainViewModel by viewModels()

    private val backPressCloseHandler = BackPressCloseHandler(this)

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = DataBindingUtil.setContentView(this, R.layout.act_main)
        binding.viewModel = viewModel
        binding.lifecycleOwner = this
    }

    override fun initDataBinding() {
    }

    override fun initAfterBinding() {

    }

    override fun onBackPressed() {
        super.onBackPressed()
        backPressCloseHandler.onBackPressed()
    }

    override fun networkConnectivityChanged(isAvailable: Boolean) {

    }
}