package com.noorija.secret.guard.view.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import com.noorija.secret.guard.databinding.ItemEmptyQrCodeBinding
import com.noorija.secret.guard.databinding.ItemCallHistoryBinding
import com.noorija.secret.guard.rest.CallHistory
import com.noorija.secret.guard.viewmodel.fragment.CallHistoryFragmentViewModel

class CallHistoryAdapter(val viewmodel : CallHistoryFragmentViewModel): BaseRecyclerAdapter<CallHistory>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder<CallHistory> {
        return if(getItemViewType(viewType) == VIEW_TYPE_NORMAL) {
            val binding = ItemCallHistoryBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            RecyclerViewHolder(
                binding,
                this,
                viewmodel
            )
        } else {
            val binding = ItemEmptyQrCodeBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            EmptyViewHolder(
                binding,
                this
            )
        }
    }

    class RecyclerViewHolder(
        private var itemBinding: ItemCallHistoryBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<CallHistory>,
        viewmodel: CallHistoryFragmentViewModel
    ): ViewHolder<CallHistory>(itemBinding.root, baseRecyclerAdapter) {

        private val vm = viewmodel

        override fun populate(item: CallHistory, position: Int) {
            itemBinding.data = item
            itemBinding.viewModel = vm

//            itemBinding.tvCarInfo.text = "${item.carInfo} : (${item.nickNm})"

        }

    }

    class EmptyViewHolder(
        itemEmptyBinding: ItemEmptyQrCodeBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<CallHistory>
    ): ViewHolder<CallHistory>(itemEmptyBinding.root, baseRecyclerAdapter)

}