package com.noorija.secret.guard.view.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.ObservableBoolean
import com.noorija.secret.guard.databinding.ItemEmptyBinding
import com.noorija.secret.guard.databinding.ItemTutorialTermsBinding
import com.noorija.secret.guard.rest.CasMngInfo
import com.noorija.secret.guard.viewmodel.TutorialViewModel

class CasRecyclerAdapter(val viewmodel : TutorialViewModel): BaseRecyclerAdapter<CasMngInfo>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder<CasMngInfo> {
        return if(getItemViewType(viewType) == VIEW_TYPE_NORMAL) {
            val binding = ItemTutorialTermsBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            RecyclerViewHolder(
                binding,
                this,
                viewmodel
            )
        } else {
            val binding = ItemEmptyBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            EmptyViewHolder(
                binding,
                this
            )
        }
    }

    class RecyclerViewHolder(
        private var itemBinding: ItemTutorialTermsBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<CasMngInfo>,
        viewmodel: TutorialViewModel
    ): ViewHolder<CasMngInfo>(itemBinding.root, baseRecyclerAdapter) {

        private val vm = viewmodel

        override fun populate(item: CasMngInfo, position: Int) {
            item.checked = ObservableBoolean(false)
            itemBinding.data = item
            itemBinding.viewModel = vm
        }

    }

    class EmptyViewHolder(
        itemEmptyBinding: ItemEmptyBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<CasMngInfo>
    ): ViewHolder<CasMngInfo>(itemEmptyBinding.root, baseRecyclerAdapter)

}