package com.noorija.secret.guard.view.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.noorija.secret.guard.R
import com.noorija.secret.guard.databinding.ItemTutorialTermsBinding
import com.noorija.secret.guard.rest.CasMngInfo

class CasRecyclerAdapterBak(val tvCasNmClick: (CasMngInfo) -> Unit, val cbCasClick: (CasMngInfo) -> Unit)
    : ListAdapter<CasMngInfo, CasRecyclerAdapterBak.MyViewHolder>(diffUtil) {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MyViewHolder {
        val layoutInflater = LayoutInflater.from(parent.context)
        val binding = DataBindingUtil.inflate<ItemTutorialTermsBinding>(layoutInflater,viewType,parent,false)
        return MyViewHolder(binding)
    }

    override fun getItemViewType(position: Int): Int {
        return R.layout.item_tutorial_terms
    }

    override fun getItemCount(): Int {
        return super.getItemCount()
    }


    override fun onBindViewHolder(holder: MyViewHolder, position: Int) {
        val casMngInfo = getItem(position)
        holder.bind(casMngInfo)
    }

    inner class MyViewHolder(private val binding: ItemTutorialTermsBinding): RecyclerView.ViewHolder(binding.root) {
        fun bind(item : CasMngInfo){
            binding.data = item
            binding.executePendingBindings()

//            binding.root.setOnClickListener {
            binding.tvCasNm.setOnClickListener {
                tvCasNmClick(item)
            }
            binding.cbCas.setOnLongClickListener {
                cbCasClick(item)
                true
            }
        }
    }

    companion object {
        val diffUtil = object: DiffUtil.ItemCallback<CasMngInfo>(){
            override fun areItemsTheSame(oldItem: CasMngInfo, newItem: CasMngInfo): Boolean {
                return oldItem == newItem
            }

            override fun areContentsTheSame(oldItem: CasMngInfo, newItem: CasMngInfo): Boolean {
                return oldItem == newItem
            }

        }
    }

}