package com.noorija.secret.guard.view.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.noorija.secret.guard.databinding.ItemTutorialTermsBinding
import com.noorija.secret.guard.rest.CasMngInfo

class CasRecyclerAdapter_0813: ListAdapter<CasMngInfo, CasRecyclerAdapter_0813.MyViewHolder>(diffUtil) {
    inner class MyViewHolder(private val binding: ItemTutorialTermsBinding): RecyclerView.ViewHolder(binding.root) {
        fun bind(item : CasMngInfo){
            binding.data = item
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MyViewHolder {
        return MyViewHolder(ItemTutorialTermsBinding.inflate(LayoutInflater.from(parent.context),parent,false))
    }

    override fun onBindViewHolder(holder: MyViewHolder, position: Int) {
        holder.bind(currentList[position])
    }

    companion object {
        val diffUtil = object: DiffUtil.ItemCallback<CasMngInfo>(){
            override fun areItemsTheSame(oldItem: CasMngInfo, newItem: CasMngInfo): Boolean {
                return oldItem == newItem
            }

            override fun areContentsTheSame(oldItem: CasMngInfo, newItem: CasMngInfo): Boolean {
                return oldItem == newItem
            }

        }
    }

}