package com.noorija.secret.guard.view.adapter

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import androidx.annotation.NonNull
import androidx.recyclerview.widget.RecyclerView
import androidx.recyclerview.widget.RecyclerView.ViewHolder
import com.bumptech.glide.Glide
import com.noorija.secret.guard.R

class GuidePagerAdapter(private var listData: List<String>) : RecyclerView.Adapter<GuidePagerAdapter.GuidePagerViewHolder>() {

    inner class GuidePagerViewHolder(@NonNull itemView: View) : ViewHolder(itemView) {
        private val ivGuide: ImageView = itemView.findViewById(R.id.ivGuide)

        fun onBind(guidePath: Any?) {
            Glide.with(ivGuide.context)
                .load(guidePath)
                .dontAnimate()
                .into(ivGuide)
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): GuidePagerViewHolder {
        var view = LayoutInflater.from(parent.context).inflate(R.layout.item_pager_guide, parent, false)
        return GuidePagerViewHolder(view)
    }

    override fun onBindViewHolder(holder: GuidePagerViewHolder, position: Int) {
        holder.onBind(listData[position])
    }

    override fun getItemCount(): Int = listData.size

}