package com.noorija.secret.guard.view.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import com.noorija.secret.guard.databinding.ItemEmptyBinding
import com.noorija.secret.guard.databinding.ItemHomeBinding
import com.noorija.secret.guard.rest.CasMngInfo
import com.noorija.secret.guard.viewmodel.fragment.HomeFragmentViewModel

class HomeRecyclerAdapter(val viewmodel : HomeFragmentViewModel): BaseRecyclerAdapter<CasMngInfo>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder<CasMngInfo> {
        return if(getItemViewType(viewType) == VIEW_TYPE_NORMAL) {
            val binding = ItemHomeBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            RecyclerViewHolder(
                binding,
                this,
                viewmodel
            )
        } else {
            val binding = ItemEmptyBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            EmptyViewHolder(
                binding,
                this
            )
        }
    }

    class RecyclerViewHolder(
        private var itemBinding: ItemHomeBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<CasMngInfo>,
        viewmodel: HomeFragmentViewModel
    ): ViewHolder<CasMngInfo>(itemBinding.root, baseRecyclerAdapter) {

        private val vm = viewmodel

        override fun populate(item: CasMngInfo, position: Int) {
            itemBinding.data = item
            itemBinding.viewModel = vm
        }

    }

    class EmptyViewHolder(
        itemEmptyBinding: ItemEmptyBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<CasMngInfo>
    ): ViewHolder<CasMngInfo>(itemEmptyBinding.root, baseRecyclerAdapter)
}

class HomeRecyclerListener(val clickListener: (casInfo: CasMngInfo) -> Unit) {
    fun onClick(info: CasMngInfo) = clickListener(info)
//    fun onClickView(info: CasMngInfo) = clickListener(info)
//    fun onClickCheck(info: CasMngInfo) = clickListener(info)
}