package com.noorija.secret.guard.view.adapter

import android.annotation.SuppressLint
import android.view.LayoutInflater
import android.view.ViewGroup
import com.bumptech.glide.Glide
import com.noorija.secret.guard.databinding.ItemEmptyQrCodeBinding
import com.noorija.secret.guard.databinding.ItemMyQrcodeBinding
import com.noorija.secret.guard.rest.MyQrInfo
import com.noorija.secret.guard.viewmodel.fragment.MyQrcodeFragmentViewModel

class MyQrcodeAdapter(val viewmodel : MyQrcodeFragmentViewModel): BaseRecyclerAdapter<MyQrInfo>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder<MyQrInfo> {
        return if(getItemViewType(viewType) == VIEW_TYPE_NORMAL) {
            val binding = ItemMyQrcodeBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            RecyclerViewHolder(
                binding,
                this,
                viewmodel
            )
        } else {
            val binding = ItemEmptyQrCodeBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            EmptyViewHolder(
                binding,
                this
            )
        }
    }

    class RecyclerViewHolder(
        private var itemBinding: ItemMyQrcodeBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<MyQrInfo>,
        viewmodel: MyQrcodeFragmentViewModel
    ): ViewHolder<MyQrInfo>(itemBinding.root, baseRecyclerAdapter) {

        private val vm = viewmodel

        override fun populate(item: MyQrInfo, position: Int) {
            itemBinding.data = item
            itemBinding.viewModel = vm

            itemBinding.tvCarInfo.text = "${item.nickNm} : (${item.qrOwnerNm})"
            itemBinding.tvRegDate.text = "등록일 : ${item.addDt}"

            Glide.with(itemBinding.ivProfile.context)
                .load(item.filePath)
                .dontAnimate()
                .into(itemBinding.ivProfile)
        }

    }

    class EmptyViewHolder(
        itemEmptyBinding: ItemEmptyQrCodeBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<MyQrInfo>
    ): ViewHolder<MyQrInfo>(itemEmptyBinding.root, baseRecyclerAdapter)

}