package com.noorija.secret.guard.view.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import com.noorija.secret.guard.databinding.ItemEmptyBinding
import com.noorija.secret.guard.databinding.ItemNoticeListBinding
import com.noorija.secret.guard.rest.PublicInfo
import com.noorija.secret.guard.viewmodel.NoticeListViewModel

class NoticeRecyclerAdapter(val viewmodel : NoticeListViewModel): BaseRecyclerAdapter<PublicInfo>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder<PublicInfo> {
        return if(getItemViewType(viewType) == VIEW_TYPE_NORMAL) {
            val binding = ItemNoticeListBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            RecyclerViewHolder(
                binding,
                this,
                viewmodel
            )
        } else {
            val binding = ItemEmptyBinding.inflate(LayoutInflater.from(parent.context), parent, false)
            EmptyViewHolder(
                binding,
                this
            )
        }
    }

    class RecyclerViewHolder(
        private var itemBinding: ItemNoticeListBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<PublicInfo>,
        viewmodel: NoticeListViewModel
    ): ViewHolder<PublicInfo>(itemBinding.root, baseRecyclerAdapter) {

        private val vm = viewmodel

        override fun populate(item: PublicInfo, position: Int) {
            itemBinding.data = item
            itemBinding.viewModel = vm
        }

    }

    class EmptyViewHolder(
        itemEmptyBinding: ItemEmptyBinding,
        baseRecyclerAdapter: BaseRecyclerAdapter<PublicInfo>
    ): ViewHolder<PublicInfo>(itemEmptyBinding.root, baseRecyclerAdapter)

}