package com.noorija.secret.guard.view.adapter

import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.fragment.app.FragmentStatePagerAdapter
import com.noorija.secret.guard.view.fragment.CallHistoryFragment
import com.noorija.secret.guard.view.fragment.MyQrcodeFragment
import com.noorija.secret.guard.view.fragment.PublicRegistFragment


class TabsHomeAdapter(fm: FragmentManager, private var totalTabs: Int)
    : FragmentStatePagerAdapter(fm, BEHAVIOR_RESUME_ONLY_CURRENT_FRAGMENT) {
    override fun getCount(): Int {
        return totalTabs
    }

    override fun getItem(position: Int): Fragment {
        return when (position) {
            0 -> {
                MyQrcodeFragment.newInstance()
            }
            1 -> {
                CallHistoryFragment.newInstance()
            }
            2 -> {
                PublicRegistFragment.newInstance()
            }
            else -> null!!
        }
    }
}