package com.noorija.secret.guard.view.fragment

import android.os.Bundle
import androidx.fragment.app.viewModels
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.noorija.secret.guard.R
import com.noorija.secret.guard.databinding.FmtCallHistoryBinding
import com.noorija.secret.guard.view.adapter.CallHistoryAdapter
import com.noorija.secret.guard.viewmodel.fragment.CallHistoryFragmentViewModel

class CallHistoryFragment : BaseFragment<FmtCallHistoryBinding, CallHistoryFragmentViewModel>() {
    companion object {
        @JvmStatic
        fun newInstance() =
            CallHistoryFragment().apply {
                arguments = Bundle().apply {
                }
            }
    }

    override val layoutResourceId: Int
        get() = R.layout.fmt_call_history
    override val viewModel : CallHistoryFragmentViewModel by viewModels()

    private lateinit var mRecyclerAdapter : CallHistoryAdapter

    override fun initDataBinding() {
        viewDataBinding.viewModel = viewModel
        setRecyclerView()
    }

    override fun initAfterBinding() {
    }

    private fun setRecyclerView() {

        mRecyclerAdapter = CallHistoryAdapter(viewModel)
        viewDataBinding.callHistRecyclerView.apply {
            adapter = mRecyclerAdapter
            layoutManager = LinearLayoutManager(requireContext(), RecyclerView.VERTICAL, false)
        }

        viewDataBinding.callHistRecyclerView.addOnScrollListener(object : RecyclerView.OnScrollListener() {
            override fun onScrollStateChanged(recyclerView: RecyclerView, newState: Int) {
                super.onScrollStateChanged(recyclerView, newState)
                val layoutManager = recyclerView.layoutManager as LinearLayoutManager
                val totalItemCount = layoutManager.itemCount
                val lastVisible = layoutManager.findLastCompletelyVisibleItemPosition()
                if (lastVisible >= totalItemCount - 1) {
                    viewModel.getCallHistoryList()
                }
            }
        })
    }
}