package com.noorija.secret.guard.view.fragment

import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.DialogFragment
import com.noorija.secret.guard.databinding.DlgCustomPopupBinding

class CustomDialogFragment(val title: String, val content: String) : DialogFragment() {
    private var _binding: DlgCustomPopupBinding? = null
    private val binding get() = _binding!!

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View {
        _binding = DlgCustomPopupBinding.inflate(inflater, container, false)
        val view = binding.root
        // 레이아웃 배경을 투명하게
//        dialog?.window?.setBackgroundDrawable(ColorDrawable(Color.TRANSPARENT))

        // 제목, 내용 설정
        binding.title.text = title
        binding.message.text = content

        // 취소 버튼
        binding.btnCancel.setOnClickListener {
            dismiss()
        }
        // 확인 버튼
        binding.btnConfirm.setOnClickListener {
            buttonClickListener.onConfirmClicked()
            dismiss()
        }

        return view
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }

    interface OnButtonClickListener {
        fun onConfirmClicked()
    }

    fun setButtonClickListener(buttonClickListener: OnButtonClickListener) {
        this.buttonClickListener = buttonClickListener
    }

    private lateinit var buttonClickListener: OnButtonClickListener
}