package com.noorija.secret.guard.viewmodel

import android.app.Application
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import com.noorija.secret.guard.rest.ExceptionDTO
import com.noorija.secret.guard.rest.FaqInfo
import com.noorija.secret.guard.rest.FaqListResponse
import com.noorija.secret.guard.text.PageView
import com.noorija.secret.guard.util.SingleLiveEvent
import com.noorija.secret.guard.util.SystemUtil

class FaqListViewModel(application: Application): BaseViewModel<Any>(application) {

    val closeEvent: SingleLiveEvent<Any> = SingleLiveEvent()

    private var _faqList = MutableLiveData<List<FaqInfo>>()
    val faqList : LiveData<List<FaqInfo>>
        get() = _faqList

    init {
        reqFaqList()
    }

    fun reqFaqList() {
        addDisposable(
            restClient.faqList(getToken(), SystemUtil.getSystemLanguage(context))
            , dataObserver
        )
    }

    fun onClickFaqView(faq: FaqInfo){
    }

    fun onClickClose(){
        closeEvent.value = PageView.BACK
    }

    override fun onRetrieveDataSuccess(data: Any) {
        when (data) {
            is FaqListResponse -> {
                _faqList.value = data.faqInfoList
            }
        }
    }

    override fun onRetrieveDataError(resError: ExceptionDTO?) {
        showToast(resError?.message)
    }

}