package com.noorija.secret.guard.viewmodel

import android.Manifest
import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.noorija.secret.guard.rest.ExceptionDTO
import com.noorija.secret.guard.rest.TutoInfo
import com.noorija.secret.guard.rest.TutoListResponse
import com.noorija.secret.guard.util.SingleLiveEvent
import com.noorija.secret.guard.util.SystemUtil


class GuideViewModel(application: Application): BaseViewModel<Any>(application) {
    private val permissions = arrayOf(
        Manifest.permission.READ_PHONE_STATE,
        Manifest.permission.CAMERA,
        Manifest.permission.READ_EXTERNAL_STORAGE
    )

    val startEvent: SingleLiveEvent<Unit> = SingleLiveEvent()
    val guideEvent: SingleLiveEvent<List<String>> = SingleLiveEvent()

    var isBtnEnable = MutableLiveData<Boolean>(false)
    var isBottomVisibility = MutableLiveData<Boolean>(false)

//    var bottomVisibility: MutableLiveData<Boolean> = MutableLiveData(false)

    init {
        getTutorial()
    }

    private fun getTutorial() {
        addDisposable(
            restClient.getTutorial(SystemUtil.getSystemLanguage(context))
            , dataObserver
        )
    }

    fun onClickStart() {
        startEvent.call()
    }

    override fun onRetrieveDataSuccess(data: Any) {
        when (data) {
            is TutoListResponse -> {
                requestPermissions(permissions) { }
                val arrGuideImage = ArrayList<String>()
                for(item: TutoInfo in data.tutoDataList) {
                    arrGuideImage.add(item.filePath)
                }
                guideEvent.value = arrGuideImage
            }
        }
    }

    override fun onRetrieveDataError(resError: ExceptionDTO?) {
        showToast(resError?.message)
    }

}