package com.noorija.secret.guard.viewmodel

import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.noorija.secret.guard.rest.ExceptionDTO
import com.noorija.secret.guard.rest.TutoInfo
import com.noorija.secret.guard.rest.TutoListResponse
import com.noorija.secret.guard.text.PageView
import com.noorija.secret.guard.util.SingleLiveEvent
import com.noorija.secret.guard.util.SystemUtil


class ManualViewModel(application: Application): BaseViewModel<Any>(application) {

    val closeEvent: SingleLiveEvent<Any> = SingleLiveEvent()
    val manualEvent: SingleLiveEvent<List<String>> = SingleLiveEvent()

    init {
        getTutorial()
    }

    private fun getTutorial() {
        addDisposable(
            restClient.getTutorial(SystemUtil.getSystemLanguage(context))
            , dataObserver
        )
    }

    fun onClickClose(){
        closeEvent.value = PageView.BACK
    }

    override fun onRetrieveDataSuccess(data: Any) {
        when (data) {
            is TutoListResponse -> {
                val arrGuideImage = ArrayList<String>()
                for(item: TutoInfo in data.tutoDataList) {
                    arrGuideImage.add(item.filePath)
                }
                manualEvent.value = arrGuideImage
            }
        }
    }

    override fun onRetrieveDataError(resError: ExceptionDTO?) {
        showToast(resError?.message)
    }

}