package com.noorija.secret.guard.viewmodel.fragment

import android.app.Application
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import com.noorija.secret.guard.rest.CasMngInfo
import com.noorija.secret.guard.rest.CasMngListResponse
import com.noorija.secret.guard.rest.ExceptionDTO
import com.noorija.secret.guard.rest.TutoInfo
import com.noorija.secret.guard.rest.TutoListResponse
import com.noorija.secret.guard.util.SingleLiveEvent
import com.noorija.secret.guard.util.SystemUtil
import com.noorija.secret.guard.viewmodel.BaseViewModel

class HomeFragmentViewModel(application: Application) : BaseViewModel<Any>(application) {

    val fmtHomeEvent: SingleLiveEvent<Any> = SingleLiveEvent()

    private var _casList = MutableLiveData<List<CasMngInfo>>()
    val casList : LiveData<List<CasMngInfo>>
        get() = _casList

    init {
        getCas()
    }

    private fun getCas() {
        if(!_casList.value.isNullOrEmpty()) return

        addDisposable(
            restClient.getCas(SystemUtil.getSystemLanguage(context))
            , dataObserver
        )
    }

    fun onClickTermsView(item: CasMngInfo) {
    }

    fun onClickTermsAgree(item: CasMngInfo) {
    }

    override fun onRetrieveDataSuccess(data: Any) {
        when (data) {
            is CasMngListResponse -> {
                _casList.value = data.casMngDataList
            }
        }
    }

    override fun onRetrieveDataError(resError: ExceptionDTO?) {
        showToast(resError?.message)
    }

}